/*
 * Created on 01.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.jvnet.hypercompass.runtime.compass.accessor;

import java.lang.reflect.Method;
import java.util.List;

import org.compass.core.CompassException;
import org.compass.core.accessor.BasicPropertyAccessor;
import org.compass.core.accessor.DirectPropertyAccessor;
import org.compass.core.accessor.Getter;
import org.compass.core.accessor.PropertyAccessor;
import org.compass.core.accessor.PropertyNotFoundException;
import org.compass.core.accessor.Setter;

import com.sun.xml.bind.util.ListImpl;

/**
 * @author valikov
 */
public class ListAccessor implements PropertyAccessor {

  private static final PropertyAccessor DIRECT_PROPERTY_ACCESSOR = new DirectPropertyAccessor();
  private static final PropertyAccessor BASIC_PROPERTY_ACCESSOR = new BasicPropertyAccessor();

  public Getter getGetter(Class theClass, String name) throws PropertyNotFoundException {

    final Getter listGetter = BASIC_PROPERTY_ACCESSOR.getGetter(theClass, name);
    final Getter coreGetter = DIRECT_PROPERTY_ACCESSOR.getGetter(ListImpl.class, "core");
    return new ListGetter(name, listGetter, coreGetter);
  }

public Setter getSetter(Class theClass, String name) throws PropertyNotFoundException {
    if (theClass.isInterface()) {
      return new NamedListSetter("_" + name);
    }
    else {
      final Setter setter = DIRECT_PROPERTY_ACCESSOR.getSetter(theClass, "_" + name);
      return new ListSetter(name, setter);
    }
  }  private static class ListGetter implements Getter {
    private final String name;
    private final Getter listGetter;
    private final Getter propertyGetter;

    public ListGetter(final String name, final Getter listGetter, final Getter propertyGetter) {
      this.name = name;
      this.listGetter = listGetter;
      this.propertyGetter = propertyGetter;
    }

    public String getName() {
      return name;
    }

    public Object get(Object object) throws CompassException {
      final Object list = listGetter.get(object);
      Object value = propertyGetter.get(list);
      return value;
    }

    public Method getMethod() {
      return null;
    }

    public String getMethodName() {
      return null;
    }

    public Class getReturnType() {
      return List.class;
    }
  }

  private static class ListSetter implements Setter {

    private final String name;
    private final Setter setter;

    public ListSetter(final String name, final Setter setter) {
      this.name = name;
      this.setter = setter;
    }

    public String getName() {
      return name;
    }

    public void set(Object object, Object value) throws CompassException {
      final ListImpl list = new ListImpl((List) value);
      list.setModified(true);
      setter.set(object, list);
    }

    public Method getMethod() {
      return null;
    }

    public String getMethodName() {
      return null;
    }
  }

  private static class NamedListSetter implements Setter {

    private final String name;

    public NamedListSetter(final String name) {
      this.name = name;
    }

    public String getName() {
      return name;
    }

    public void set(Object object, Object value) throws CompassException {

      final Setter setter = DIRECT_PROPERTY_ACCESSOR.getSetter(object.getClass(), name);
      final ListImpl list = new ListImpl((List) value);
      list.setModified(true);
      setter.set(object, list);
    }

    public Method getMethod() {
      return null;
    }

    public String getMethodName() {
      return null;
    }
  }
}
